Name:           jsonnet
Version:        0.20.0
%global so_version 0
Release:    1%{?dist}
Summary:        A data templating language based on JSON

License:        Apache-2.0 AND MIT AND CC0-1.0

URL:            https://github.com/google/jsonnet
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

Source1:        jsonnet.1
Source2:        jsonnetfmt.1

Patch0:          0001-Dynamic-link-to-libjsonnet-rather-than-static.patch
Patch1:          0002-jsonnet-0.17.0-do-not-override-compiler-flags.patch
Patch2:          0003-jsonnet-0.19.1-Use-system-provided-rapidyaml.patch

Provides:       bundled(md5-thilo)

BuildRequires:  python3-devel

BuildRequires:  bash cmake gcc gcc-c++ gtest-devel make

BuildRequires:  json-devel json-static
BuildRequires:  rapidyaml-devel

Requires:       %{name}-libs = %{version}-%{release}

%global _description %{expand:
A data templating language for app and tool developers based on JSON}

%description %{_description}


%package -n python3-%{name}
Summary:        %{name} Bindings for Python
Requires:       %{name}-libs = %{version}-%{release}

%description -n python3-%{name} %{_description}


%package libs
Summary:        Shared Libraries for %{name}

%description libs %{_description}


%package devel
Summary:        Development Headers for %{name}
License:        Apache-2.0

Requires:       %{name}-libs = %{version}-%{release}

%description devel %{_description}


%package doc
Summary:        Documentation for %{name}
License:        Apache-2.0 AND CC-BY-2.5
BuildArch:      noarch

%description doc %{_description}


%prep
%autosetup

rm -rfv third_party/json/*

rm -rfv third_party/rapidyaml/*

rm -rf doc/third_party
rm -rf doc/.gitignore

find doc examples -type f -perm /0111 -name '*.sh' -print0 |
  xargs -r -0 -t sed -r -i '1{s@^#!/usr/bin/env[[:blank:]]+bash@#!/bin/bash@}'


%generate_buildrequires
%pyproject_buildrequires


%build
export CXXFLAGS="%{optflags} -fPIC -I%{_includedir}/nlohmann"

%cmake -DBUILD_SHARED_BINARIES:BOOL=ON -DBUILD_STATIC_LIBS:BOOL=OFF -DUSE_SYSTEM_JSON:BOOL=ON -DUSE_SYSTEM_GTEST:BOOL=ON

%cmake_build

%pyproject_wheel


%install
%{cmake_install}

%pyproject_install
%pyproject_save_files _jsonnet

install -d '%{buildroot}%{_mandir}/man1'
install -t '%{buildroot}%{_mandir}/man1' -p -m 0644 '%{SOURCE1}' '%{SOURCE2}'


%check
%ctest

LD_LIBRARY_PATH='%{buildroot}%{_libdir}' \
    PYTHONPATH='%{buildroot}%{python3_sitearch}' \
    %{python3} python/_jsonnet_test.py


%files
%{_bindir}/jsonnet
%{_bindir}/jsonnetfmt
%{_mandir}/man1/jsonnet.1*
%{_mandir}/man1/jsonnetfmt.1*

%files libs
%license LICENSE
%doc README.md
%{_libdir}/lib%{name}.so.%{so_version}{,.*}
%{_libdir}/lib%{name}++.so.%{so_version}{,.*}

%files devel
%{_includedir}/lib%{name}*
%{_libdir}/lib%{name}.so
%{_libdir}/lib%{name}++.so

%files -n python3-%{name} -f %{pyproject_files}

%files doc
%license LICENSE
%doc README.md
%doc CONTRIBUTING
%doc doc
%doc examples


%changelog
* Mon Jul 01 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.20.0-1
- initial build
